Index: cpu/arm720t/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/arm720t/config.mk,v
retrieving revision 1.1.1.1
diff -p -u -r1.1.1.1 config.mk
--- cpu/arm720t/config.mk	5 Sep 2002 14:51:08 -0000	1.1.1.1
+++ cpu/arm720t/config.mk	14 Aug 2005 16:34:37 -0000
@@ -23,6 +23,6 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4 -mtune=arm7tdmi
Index: cpu/arm920t/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/arm920t/config.mk,v
retrieving revision 1.1.1.1
diff -p -u -r1.1.1.1 config.mk
--- cpu/arm920t/config.mk	5 Sep 2002 14:50:51 -0000	1.1.1.1
+++ cpu/arm920t/config.mk	14 Aug 2005 16:34:37 -0000
@@ -22,6 +22,6 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4
Index: cpu/arm925t/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/arm925t/config.mk,v
retrieving revision 1.1
diff -p -u -r1.1 config.mk
--- cpu/arm925t/config.mk	15 Jul 2003 20:04:06 -0000	1.1
+++ cpu/arm925t/config.mk	14 Aug 2005 16:34:37 -0000
@@ -22,6 +22,6 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4
Index: cpu/arm926ejs/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/arm926ejs/config.mk,v
retrieving revision 1.1
diff -p -u -r1.1 config.mk
--- cpu/arm926ejs/config.mk	29 Aug 2003 22:00:47 -0000	1.1
+++ cpu/arm926ejs/config.mk	14 Aug 2005 16:34:37 -0000
@@ -22,6 +22,6 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4
Index: cpu/ixp/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/ixp/config.mk,v
retrieving revision 1.1
diff -p -u -r1.1 config.mk
--- cpu/ixp/config.mk	14 Oct 2003 19:43:56 -0000	1.1
+++ cpu/ixp/config.mk	14 Aug 2005 16:34:37 -0000
@@ -25,6 +25,6 @@
 BIG_ENDIAN = y
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float -mbig-endian
+	-msoft-float -mbig-endian
 
 PLATFORM_CPPFLAGS += -mbig-endian -mapcs-32 -march=armv4 -mtune=strongarm1100
Index: cpu/lh7a40x/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/lh7a40x/config.mk,v
retrieving revision 1.1
diff -p -u -r1.1 config.mk
--- cpu/lh7a40x/config.mk	9 Jun 2004 13:37:53 -0000	1.1
+++ cpu/lh7a40x/config.mk	14 Aug 2005 16:34:37 -0000
@@ -22,6 +22,6 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4
Index: cpu/pxa/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/pxa/config.mk,v
retrieving revision 1.2
diff -p -u -r1.2 config.mk
--- cpu/pxa/config.mk	9 Jan 2005 21:28:17 -0000	1.2
+++ cpu/pxa/config.mk	14 Aug 2005 16:34:37 -0000
@@ -23,7 +23,7 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 #PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4 -mtune=strongarm1100
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv5 -mtune=xscale
Index: cpu/s3c44b0/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/s3c44b0/config.mk,v
retrieving revision 1.1
diff -p -u -r1.1 config.mk
--- cpu/s3c44b0/config.mk	24 Feb 2004 00:16:44 -0000	1.1
+++ cpu/s3c44b0/config.mk	14 Aug 2005 16:34:37 -0000
@@ -23,6 +23,6 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4 -mtune=arm7tdmi -msoft-float
Index: cpu/sa1100/config.mk
===================================================================
RCS file: /cvsroot/u-boot/u-boot/cpu/sa1100/config.mk,v
retrieving revision 1.1.1.1
diff -p -u -r1.1.1.1 config.mk
--- cpu/sa1100/config.mk	5 Sep 2002 14:51:11 -0000	1.1.1.1
+++ cpu/sa1100/config.mk	14 Aug 2005 16:34:37 -0000
@@ -23,6 +23,6 @@
 #
 
 PLATFORM_RELFLAGS += -fno-strict-aliasing  -fno-common -ffixed-r8 \
-	-mshort-load-bytes -msoft-float
+	-msoft-float
 
 PLATFORM_CPPFLAGS += -mapcs-32 -march=armv4 -mtune=strongarm1100