Index: u-boot-cvs-20050622/board/cogent/README.cma286
===================================================================
--- u-boot-cvs-20050622.orig/board/cogent/README.cma286	2005-06-22 18:30:49.540857000 +1000
+++ u-boot-cvs-20050622/board/cogent/README.cma286	2005-06-22 18:36:04.180091000 +1000
@@ -65,5 +65,5 @@
 If anyone finds anything wrong with the stuff above, I would appreciate
 an email about it.
 
-Murray Jensen <Murray.Jensen@cmst.csiro.au>
+Murray Jensen <Murray.Jensen@csiro.au>
 21-Aug-00
Index: u-boot-cvs-20050622/CREDITS
===================================================================
--- u-boot-cvs-20050622.orig/CREDITS	2005-06-22 18:30:49.191841000 +1000
+++ u-boot-cvs-20050622/CREDITS	2005-06-22 18:36:04.124423000 +1000
@@ -198,10 +198,9 @@
 W: www.denx.de
 
 N: Murray Jensen
-E: Murray.Jensen@cmst.csiro.au
+E: Murray.Jensen@csiro.au
 D: Initial 8260 support; GDB support
 D: Port to Cogent+Hymod boards; Hymod Board Database
-W: http://www.msa.cmst.csiro.au/ourstaff/MurrayJensen/mjj.html
 
 N: Yoo. Jonghoon
 E: yooth@ipone.co.kr
Index: u-boot-cvs-20050622/MAINTAINERS
===================================================================
--- u-boot-cvs-20050622.orig/MAINTAINERS	2005-06-22 18:30:49.375565000 +1000
+++ u-boot-cvs-20050622/MAINTAINERS	2005-06-22 18:36:04.142844000 +1000
@@ -157,7 +157,7 @@
 	KUP4K			MPC855
 	KUP4X			MPC859
 
-Murray Jensen <Murray.Jensen@cmst.csiro.au>
+Murray Jensen <Murray.Jensen@csiro.au>
 
 	cogent_mpc8xx		MPC8xx
 
Index: u-boot-cvs-20050622/tools/bddb/badsubmit.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/badsubmit.php	2005-06-22 18:30:49.817684000 +1000
+++ u-boot-cvs-20050622/tools/bddb/badsubmit.php	2005-06-22 18:36:04.238908000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	require("defs.php");
Index: u-boot-cvs-20050622/tools/bddb/brlog.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/brlog.php	2005-06-22 18:30:49.953027000 +1000
+++ u-boot-cvs-20050622/tools/bddb/brlog.php	2005-06-22 18:36:04.276299000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// list page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/browse.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/browse.php	2005-06-22 18:30:50.091854000 +1000
+++ u-boot-cvs-20050622/tools/bddb/browse.php	2005-06-22 18:36:04.309761000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// list page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/config.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/config.php	2005-06-22 18:30:50.233261000 +1000
+++ u-boot-cvs-20050622/tools/bddb/config.php	2005-06-22 18:36:04.339424000 +1000
@@ -1,6 +1,6 @@
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// mysql database access info
Index: u-boot-cvs-20050622/tools/bddb/create_tables.sql
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/create_tables.sql	2005-06-22 18:30:50.362344000 +1000
+++ u-boot-cvs-20050622/tools/bddb/create_tables.sql	2005-06-22 18:36:04.364196000 +1000
@@ -4,8 +4,8 @@
 # Host: localhost Database : hymod_bddb
 
 # (C) Copyright 2001
-# Murray Jensen <Murray.Jensen@cmst.csiro.au>
-# CSIRO Manufacturing Science and Technology, Preston Lab
+# Murray Jensen <Murray.Jensen@csiro.au>
+# CSIRO Manufacturing and Infrastructure Technology, Preston Lab
 
 # --------------------------------------------------------
 #
Index: u-boot-cvs-20050622/tools/bddb/defs.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/defs.php	2005-06-22 18:30:50.503872000 +1000
+++ u-boot-cvs-20050622/tools/bddb/defs.php	2005-06-22 18:36:04.382495000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// contains mysql user id and password - keep secret
@@ -108,7 +108,7 @@
 		echo "<hr></hr>\n";
 		echo "<table width=\"100%\"><tr><td align=left>\n<address>" .
 			"If you have any problems, email " .
-			"<a href=\"mailto:Murray.Jensen@cmst.csiro.au\">" .
+			"<a href=\"mailto:Murray.Jensen@csiro.au\">" .
 			"Murray Jensen" .
 			"</a></address>\n" .
 			"</td><td align=right>\n" .
Index: u-boot-cvs-20050622/tools/bddb/dodelete.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/dodelete.php	2005-06-22 18:30:50.639839000 +1000
+++ u-boot-cvs-20050622/tools/bddb/dodelete.php	2005-06-22 18:36:04.412651000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// dodelete page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/dodellog.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/dodellog.php	2005-06-22 18:30:50.770397000 +1000
+++ u-boot-cvs-20050622/tools/bddb/dodellog.php	2005-06-22 18:36:04.429128000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// dodelete page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/doedit.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/doedit.php	2005-06-22 18:30:50.908593000 +1000
+++ u-boot-cvs-20050622/tools/bddb/doedit.php	2005-06-22 18:36:04.462472000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// doedit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/doedlog.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/doedlog.php	2005-06-22 18:30:51.046925000 +1000
+++ u-boot-cvs-20050622/tools/bddb/doedlog.php	2005-06-22 18:36:04.494135000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// doedit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/donew.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/donew.php	2005-06-22 18:30:51.175539000 +1000
+++ u-boot-cvs-20050622/tools/bddb/donew.php	2005-06-22 18:36:04.527603000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// doedit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/donewlog.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/donewlog.php	2005-06-22 18:30:51.310758000 +1000
+++ u-boot-cvs-20050622/tools/bddb/donewlog.php	2005-06-22 18:36:04.544330000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// doedit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/edit.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/edit.php	2005-06-22 18:30:51.427053000 +1000
+++ u-boot-cvs-20050622/tools/bddb/edit.php	2005-06-22 18:36:04.577403000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// edit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/edlog.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/edlog.php	2005-06-22 18:30:51.564683000 +1000
+++ u-boot-cvs-20050622/tools/bddb/edlog.php	2005-06-22 18:36:04.609030000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// edit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/execute.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/execute.php	2005-06-22 18:30:51.691826000 +1000
+++ u-boot-cvs-20050622/tools/bddb/execute.php	2005-06-22 18:36:04.644801000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	if (!isset($serno))
Index: u-boot-cvs-20050622/tools/bddb/index.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/index.php	2005-06-22 18:30:51.818947000 +1000
+++ u-boot-cvs-20050622/tools/bddb/index.php	2005-06-22 18:36:04.678372000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	require("defs.php");
Index: u-boot-cvs-20050622/tools/bddb/new.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/new.php	2005-06-22 18:30:51.948943000 +1000
+++ u-boot-cvs-20050622/tools/bddb/new.php	2005-06-22 18:36:04.702961000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// edit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/newlog.php
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/newlog.php	2005-06-22 18:30:52.074146000 +1000
+++ u-boot-cvs-20050622/tools/bddb/newlog.php	2005-06-22 18:36:04.726734000 +1000
@@ -1,7 +1,7 @@
 <?php // php pages made with phpMyBuilder <http://kyber.dk/phpMyBuilder> ?>
 <?php
 	// (C) Copyright 2001
-	// Murray Jensen <Murray.Jensen@cmst.csiro.au>
+	// Murray Jensen <Murray.Jensen@csiro.au>
 	// CSIRO Manufacturing Science and Technology, Preston Lab
 
 	// edit page (hymod_bddb / boards)
Index: u-boot-cvs-20050622/tools/bddb/README
===================================================================
--- u-boot-cvs-20050622.orig/tools/bddb/README	2005-06-22 18:30:49.667406000 +1000
+++ u-boot-cvs-20050622/tools/bddb/README	2005-06-22 18:36:04.213524000 +1000
@@ -1,7 +1,7 @@
 Hymod Board Database
 
 (C) Copyright 2001
-Murray Jensen <Murray.Jensen@cmst.csiro.au>
+Murray Jensen <Murray.Jensen@csiro.au>
 CSIRO Manufacturing Science and Technology, Preston Lab
 
 25-Jun-01
Index: u-boot-cvs-20050622/tools/gdb/Makefile
===================================================================
--- u-boot-cvs-20050622.orig/tools/gdb/Makefile	2005-06-22 18:30:52.221562000 +1000
+++ u-boot-cvs-20050622/tools/gdb/Makefile	2005-06-22 18:36:04.756509000 +1000
@@ -1,6 +1,6 @@
 #
 # (C) Copyright 2000
-# Murray Jensen <Murray.Jensen@cmst.csiro.au>
+# Murray Jensen <Murray.Jensen@csiro.au>
 #
 # See file CREDITS for list of people who contributed to this
 # project.